//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "LayerUnit.h"
#include "MainUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLayerFrm *LayerFrm;
//---------------------------------------------------------------------------
__fastcall TLayerFrm::TLayerFrm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TLayerFrm::NewLayerBtnClick(TObject *Sender)
{
MainFrm->MyCAD1->NewLayer("Layer" + IntToStr(MainFrm->MyCAD1->GetMaxLayerId() + 1));
Refreshit();
}
//---------------------------------------------------------------------------
void __fastcall TLayerFrm::Refreshit(void)
{
int i,id;

TTreeNode* SelectedNode;
TTreeNode* ANode;

LayerTreeView->Items->Clear();

for (i = 0; i < MainFrm->MyCAD1->GetLayersCount(); i++)
   {

   id = MainFrm->MyCAD1->GetLayerIdByNo(i);

   if (id > -1)
	  {
	  ANode = LayerTreeView->Items->Add(NULL, MainFrm->MyCAD1->GetLayerNameByID(id));

	  if (MainFrm->MyCAD1->IsVisibleLayerByID(id))
		 {
		 ANode->ImageIndex = 0;
		 ANode->SelectedIndex = 0;
		 }
	  else
		 {
		 ANode->ImageIndex = 1;
		 ANode->SelectedIndex = 1;
		 }

	  if (MainFrm->MyCAD1->CurrentLayerId == id)
		 {
		 SelectedNode = ANode;
		 LayerTreeView->Selected = SelectedNode;
		 }
	  }
   }
}
void __fastcall TLayerFrm::DeleteLayerBtnClick(TObject *Sender)
{
int id;

Screen->Cursor = crHourGlass;

if (LayerTreeView->Selected->Index > -1)
   {
   id = MainFrm->MyCAD1->GetLayerIdByNo(LayerTreeView->Selected->Index);
   MainFrm->MyCAD1->DeleteLayerByID(id);
   Refreshit();
   }

Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TLayerFrm::SpeedButton3Click(TObject *Sender)
{
int id;
id = MainFrm->MyCAD1->GetLayerIdByNo(LayerTreeView->Selected->Index);
if (id > -1)
   {
   if (MainFrm->MyCAD1->IsVisibleLayerByID(id))
	  MainFrm->MyCAD1->InVisibleLayerByID(id);
   else
	  MainFrm->MyCAD1->VisibleLayerByID(id);
   Refreshit();
   }
}
//---------------------------------------------------------------------------

void __fastcall TLayerFrm::FormShow(TObject *Sender)
{
Refreshit();	
}
//---------------------------------------------------------------------------

void __fastcall TLayerFrm::SpeedButton2Click(TObject *Sender)
{
Refreshit();	
}
//---------------------------------------------------------------------------

void __fastcall TLayerFrm::SpeedButton1Click(TObject *Sender)
{
Close();	
}
//---------------------------------------------------------------------------

void __fastcall TLayerFrm::LayerTreeViewEdited(TObject *Sender, TTreeNode *Node,
      AnsiString &S)
{
if (S == "") S = Node->Text;
MainFrm->MyCAD1->SetLayerNameByName(S, Node->Text);
}
//---------------------------------------------------------------------------

void __fastcall TLayerFrm::LayerTreeViewAdvancedCustomDrawItem(
	  TCustomTreeView *Sender, TTreeNode *Node, TCustomDrawState State,
	  TCustomDrawStage Stage, bool &PaintImages, bool &DefaultDraw)
{
if (State.Contains(cdsSelected))
   {
   MainFrm->MyCAD1->CurrentLayerId = MainFrm->MyCAD1->GetLayerIdByNo(Node->Index);
   }
}
//---------------------------------------------------------------------------

